apiVersion: tekton.dev/v1beta1
kind: Pipeline
metadata:
  name: tf-prepare-customer-providers
spec:
  workspaces:
    - name: providers-workspace
  params:
    - name: kubectl-version
      type: string
      default: "1.6.2"
  tasks:
    - name: wget-terraform-provider-kubectl
      taskRef:
        name: wget
      params:
        - name: url
          value: "https://github.com/gavinbunney/terraform-provider-kubectl/releases/download/v$(params.kubectl-version)/terraform-provider-kubectl_$(params.kubectl-version)_linux_amd64.zip"
        - name: diroptions
          value:
            - "-O"
        - name: filename
          value: terraform-provider-kubectl.zip
      workspaces:
        - name: wget-workspace
          workspace: providers-workspace
    - name: unarchive-terraform-provider-kubectl
      runAfter:
        - wget-terraform-provider-kubectl
      taskRef:
        name: unarchive
      params:
        - name: filename
          value: terraform-provider-kubectl.zip
      workspaces:
        - name: unzip-workspace
          workspace: providers-workspace
    - name: rm-terraform-provider-kubectl-license
      runAfter:
        - unarchive-terraform-provider-kubectl
      taskRef:
        name: rm
      params:
        - name: filename
          value: LICENSE
      workspaces:
        - name: rm-workspace
          workspace: providers-workspace
    - name: rm-terraform-provider-kubectl-readme
      runAfter:
        - unarchive-terraform-provider-kubectl
      taskRef:
        name: rm
      params:
        - name: filename
          value: README.md
      workspaces:
        - name: rm-workspace
          workspace: providers-workspace
    - name: rm-terraform-provider-kubectl-zip
      runAfter:
        - unarchive-terraform-provider-kubectl
      taskRef:
        name: rm
      params:
        - name: filename
          value: terraform-provider-kubectl.zip
      workspaces:
        - name: rm-workspace
          workspace: providers-workspace
    #--------
    - name: wget-terraform-provider-minio
      taskRef:
        name: wget
      params:
        - name: url
          value: "https://github.com/aminueza/terraform-provider-minio/releases/download/v1.1.0/terraform-provider-minio_v1.1.0_linux_amd64"
        - name: diroptions
          value:
            - "-O"
        - name: filename
          value: terraform-provider-minio
      workspaces:
        - name: wget-workspace
          workspace: providers-workspace
    - name: chmod-terraform-providers-kubectl
      runAfter:
        - unarchive-terraform-provider-kubectl
      params:
        - name: filename
          value: terraform-provider-kubectl_v$(params.kubectl-version)
      taskRef:
        name: chmod
      workspaces:
        - name: chmod-workspace
          workspace: providers-workspace
    - name: chmod-terraform-providers-minio
      runAfter:
        - wget-terraform-provider-minio
      params:
        - name: filename
          value: terraform-provider-minio
      taskRef:
        name: chmod
      workspaces:
        - name: chmod-workspace
          workspace: providers-workspace

    #--------
    - name: debug-terraform-provider-kubectl
      runAfter:
        - chmod-terraform-providers-minio
        - chmod-terraform-providers-kubectl
        - rm-terraform-provider-kubectl-license
        - rm-terraform-provider-kubectl-zip
        - rm-terraform-provider-kubectl-readme
      taskRef:
        name: debug
      workspaces:
        - name: debug-workspace
          workspace: providers-workspace
